//Pierrick Vandenbroucke

#include <iostream>
#include <fstream> //in/output file
#include <string> 
#include <vector>

using namespace std;

string::size_type whereLetter(const vector <char> alpha, const char & letter){
	int i;
	for (i = 0; i < ((int) alpha.size()); i++){
		if (alpha.at(i) == letter) return i;
	}
	return string::npos;
}

int main (int argc, char * argv[]){
	string line[256], previous, actual;
	vector<char> alphabet; 
	vector<char>::iterator it;
	char previousLetter, actualLetter;
	unsigned int nblines=0, i, j, position;
	int posActualLetter,posPreviousLetter;
	string::size_type positionDif;
	bool continueLoop;
		
	if (argc != 2){
		cerr<<"Error: Usage: ./firstAssignment fileToRead.txt"<<endl;
		return -1;
	}

	ifstream file(argv[1]); 
	if (! file){
		cerr<<"Error: File "<< argv[1] <<" doesn't exist"<<endl;
		return -2;
	}

	while (getline(file, line[nblines])){ //read a line in file 
		cout<< line[nblines] <<endl;

		if (! line[nblines].empty()) //if the line is empty, I forget it
			nblines++;

		if (nblines == 255){
			cerr<<"Error: File "<< argv[1] <<" is too large ! (buffer overflow)"<<endl;
			return -3;
		}
	}
	file.close();

	cout<<endl;
	
	i=1; //column
	while (continueLoop){
		continueLoop = false;
		previous.clear();
		cout<<i<< endl;
		
		for (j = 0; j< nblines; j++){ //line
			actual = line[j].substr(0,i);
			cout<<actual<< endl;

			if (actual.at(i-1) != ' '){
				if ((positionDif =  actual.find_last_not_of(previous)) != string::npos){
					position = (int) positionDif;
					if (i == 1){// first column
						if (whereLetter(alphabet,actual.at(position)) == string::npos){
							alphabet.push_back(actual.at(position));				
						}
					}
					else{
						if (position == (i-1)){ //difference at last column	
							if (! previous.empty()){ //previous line not empty
								if (actual.substr(0,i-1).compare(previous.substr(0,i-1)) == 0){
									actualLetter = actual.at(position);
									previousLetter = previous.at(position);
									
									if (previousLetter != ' '){
										//cout << actualLetter <<" != "<< previousLetter << endl;
									
										posPreviousLetter = whereLetter(alphabet,previousLetter);
										posActualLetter = whereLetter(alphabet,actualLetter);
										
										if (posActualLetter == -1){ //actualLetter isn't yet in alphabet
											it = find(alphabet.begin(), alphabet.end(), previousLetter);
											if (it != alphabet.end()){	
												it++;
												alphabet.insert(it,actualLetter);		
											}
										}
										
																				
										if (posActualLetter != -1){	//actualLetter is in alphabet
											if (posPreviousLetter > posActualLetter){ //actualise order
												alphabet.erase(find(alphabet.begin(), alphabet.end(), actualLetter));
												it = find(alphabet.begin(), alphabet.end(), previousLetter);
												if (it != alphabet.end()){	
													it++;
													alphabet.insert(it,actualLetter);		
												}
											}
										}
									}
								}
							}
						}							
					}
				}
				continueLoop = true;
			}	
			previous = actual;
		}		
		i++;	
	}
	
	cout<<endl;
	for (i = 0; i< alphabet.size(); i++){
		cout<< alphabet.at(i);
	}
	cout<<endl;
		
	return 0;
}
